#include <avr/io.h>
#define F_CPU 16000000
#include <util/delay.h>
#include <avr\interrupt.h>
#include <stdio.h>

#define OFF 0x00
#define ON 0xFF

#define BIT0 0x01
#define BIT1 0x02
#define BIT2 0x04
#define BIT3 0x08
#define BIT4 0x10
#define BIT5 0x20
#define BIT6 0x40
#define BIT7 0x80
#define END 10
#define A 1140671485


char model[END];

unsigned int s = 1,f = 1;

void del(int s){ 

	int i;

	for(i = 0;i< s;i++)
		_delay_ms(500);
 
}
 
	
int pressButton()
{
	int apasat = 0;
	int buton = -1;
	
	while(apasat == 0)	
	{
		if((PINB & BIT0) == 0) 
		{
			PORTA &=~ BIT0;
			while(((PINB & BIT0) == 0));
			PORTA = ON;
			apasat = 1;
			buton = 0;
			break;
		}
			
		if((PINB & BIT1) == 0) 
		{
			PORTA &=~ BIT1;
			while(((PINB & BIT1) == 0));
			PORTA = ON;
			apasat = 1;
			buton = 1;
			break;
		}
			
		if((PINB & BIT2) == 0) 
		{
			PORTA &=~ BIT2;
			while(((PINB & BIT2) == 0));
			PORTA = ON;
			apasat = 1;
			buton = 2;
			break;
		}
			
		if((PINB & BIT3) ==0) 
		{			
			PORTA &=~ BIT3;
			while(((PINB & BIT3) ==0));
			PORTA = ON;
			apasat = 1;
			buton = 3;
			break;
		}
			
		if((PINB & BIT4) ==0) 
		{
			PORTA &=~ BIT4;
			while(((PINB & BIT4) ==0));
			PORTA = ON;
			apasat = 1;
			buton = 4;
			break;
		}
			
		if((PINB & BIT5) == 0) 
		{
			PORTA &=~ BIT5;
			while(((PINB & BIT5) == 0));
			PORTA = ON;
			apasat = 1;
			buton = 5;
			break;
		}

		if((PINB & BIT6) == 0) 
		{
			PORTA &=~ BIT6;
			while(((PINB & BIT6) == 0));
			PORTA = ON;
			apasat = 1;
			buton = 6;
			break;
		}
		if((PINB & BIT7) == 0) 
		{
			PORTA &=~ BIT7;
			while(((PINB & BIT7) == 0));
			PORTA = ON;
			apasat = 1;
			buton = 7;
			break;
		}
	}
	
	return buton;	
	
}
void LED_on(char to)
{
	PORTA &=~ to;
	del(1.5);
	PORTA = ON;
}

void all_LEDs_on()
{
	PORTA = OFF;
	del(2);
	PORTA =ON;
}

int get_rand()
{
	s = (s + 231) % A;
	f = (s + f) % A;
	return (s + f) % 8;

}

int main()
{
	int cont=0;
	int act;
	int random;
	char to = BIT0;
	int i, correct, done;
	int buton;


	
	DDRA = 0xFF;
	PORTA = 0xFF; 
	DDRB = 0x00;
	PORTB = 0xFF;
	
	while(1){
				
		
		PORTB = 0xFF;										
		random = get_rand();
		model[cont] = random;
		cont = cont + 1;
		
		if (cont == END)
		{
			all_LEDs_on();
			del(1);
			all_LEDs_on();
			del(1);
			all_LEDs_on();
			del(1);
			break;
		}
		
		for(i=0;i<cont;i++)
		{
			switch(model[i])
			{
				case 0: to = BIT0; break;
				case 1: to = BIT1; break;
				case 2: to = BIT2; break;
				case 3: to = BIT3; break;
				case 4: to = BIT4; break;
				case 5: to = BIT5; break;
				case 6: to = BIT6; break;
				case 7: to = BIT7; break;
			}
			LED_on(to);
			del(1);
		}
		
		act = 0;
		done = 0;
		correct = 1;
		while(done == 0 && correct == 1)	
		{
			buton = pressButton();
			del(1);
			if(buton != -1)	
			{
				if(buton != model[act]) 
				{
					all_LEDs_on();
					del(1);
					correct = 0;
					cont = 0;
					break;
				}
			}
			act++;
			if(act >= cont)
				done = 1;			
		}
		
		

	}
	return 0;
}

